# -------------------------------------------------------------------- #
#  /////////////////////////////////\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\  #
# |||||||||||||| International Weather Script v0.739 ||||||||||||||||| #
#  \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\/////////////////////////////////  #
# -------------------------------------------------------------------- #
# 			By Ycarus - yews@zugaina.org
# All scripts are available at : http://yews.zugaina.org/
# Tous les scripts sont disponibles sur : http://yews.zugaina.org/
# e-mail : yews@zugaina.org (in english or french ONLY)

# This script is in english and french.
# Vous devez avoir http.tcl - You must have http.tcl

# You should read this file with a monospaced font.
# ======================================================================
# English comments of the script - Commentaires du script en anglais
#--------------------------------------------------------------------
# With this script you can see the weather of a city in the world.
# You can see the actual weather and the weather you will have.
# This script use the site : http://www.weather.com/
# The site weather.com and Yahoo.com use exactly the same data.
# You can have the weather in english (uk or us), french, spanish, deutch,
# and brezilian.
#
#Usage: !weather [-d] [help] [prev] [lng] <city,state|zip> [country]                 
#       or /msg bot !weather [-d] <city,state|zip> [country]
# 	"-d" will set a default allowing user to just type !weather. 
#	"prev" for forecast weather.
#	"lng" put here the language you want (us, fr, uk, es, br, de)
#
# You can enter locations in a number of ways. 
# - Zip Code 
# - City name (e.g., Atlanta, New York, Paris, etc.) 
# - City, State (e.g., Atlanta, GA or Atlanta, Georgia) 
# - City, Country (e.g., Paris, France) 
#
# If you want a city in germany, france, us,... If your script isn't in this
# language by default you should write : .wz lng city (where lng is the country
# of the city). For exemple : .wz fr nanterre display the result in french of
# the city "nanterre", and you can't find this city if the default language is
# "us"...
#
# If you have a problem you can put : !weather debug <your problem>
# Then you only have to send to me the generated file :)
#
# This script work with Eggdrop and Windrop.
#
# History :
#----------
# v0.739 (20 january 2004)
# * Correct html change for us language
# * Correct forecast weather
# * Change of the site adress
# * Sorry... no next version with xml for now...
#
# v0.738 (05 june 2004)
# * Correct a bug in us language after html change
# * correct strange deutch bug...
# * the next version will use the xml file of weather.com (I hope)
# this new version will be released next month...
#
# v0.737 (18 june 2003)
# * same problem than before but for forecast this time....
#
# v0.736 (16 june 2003)
# * redirect in html page...
#
# v0.735 (2 june 2003)
# * Bug in forecast weather...
#
# v0.734 (31 may 2003)
# * I think I should sleep a little... (bug by me)
#
# v0.733 (29 may 2003)
# * I hope it's the last bug ;)
#
# v0.732 (25 may 2003)
# * Some other bug corrected :)
#
# v0.731 (23 may 2003)
# * Little redirect on a html page fails... Not anymore
#  (it's only a temporary solution, new version soon...)
#
# V0.73 (28 february 2003)
# * You can choose the site you want : weather.com or wunderground.com
# * There is new languages. You can now use 60 languages!
# * Little bug with US url
# * Some changes in auto-update procedure
#
# V0.723 (17 february 2003)
# * Bugs for some languages
# * Changes in debug file
#
# V0.722 (5 february 2003)
# * Little change with http code
# * Change html code for uk...
#
# V0.721 (28 january 2003)
# * No more bug if the language is incorrect
# * Little change in update code
# * Little bug in default city...
#
# V0.72 (22 january 2003)
# * Little change in html for us language this time...
#
# V0.71 (10 january 2003)
# * Little change in html for uk language.
#
# V0.7 (9 january 2003)
# * You can now update the script directly by the command !update
#     with this, the update can keep all your settings.
# * Bugfixes
#
# V0.657 (8 january 2003)
# * They change again some html code in the US version... Again...
# * Now the script support when  is <0
# * Happy new year !
#
# V0.656 (23 november 2002)
# * They change again some html code in the US version...
#
# V0.655 (10 september 2002)
# * Little change in the html code of the site
#
# V0.654 (10 august 2002)
# * Translation of the help in german by Binzi
#
# V0.653 (16 july 2002)
# * A little bug with the site... (strange redirection...)
#
# V0.652 (20 june 2002)
# * I hope this time it's ok...
#
# V0.651 (19 june 2002)
# * a little small bug ;)
#
# V0.65 (19 june 2002)
# * Bugfixes... (thank to McGuyver, Tommy Dool, Thornes, Aser,... to send me the bugs :)
# * A redirector if there is an error 301 or 302.
#
# V0.64 (15 june 2002)
# * The site change some html code
# * You can now see C and F (for all languages) also you can see mph and km/h (only if default is us)
#
# vx.xx (some other version, but too long history...)
#
# v0.5B
# * First public version
#
# Todo :
#-------
# * Give weather for the day you want...
# * Possibility to choose some other website
# * Script can auto adapt himself when there is a html code change

# Sorry for my very bad english, I'm french...

# ======================================================================
# Commentaires du script en franais - French comments of the script
#--------------------------------------------------------------------
# Ce script permet d'afficher la mto d'une ville n'importe o dans
# le monde. Vous pouvez voir la mto actuelle ou les prvisions pour
# les 10 prochains jours.
# Vous pouvez avoir la mto en anglais (uk ou us), franais, espagnol,
# brsilien, et allemand.
#
#Usage: !meteo [-d] [aide] [prev] [lng] <ville,tat> [pays]                 
#       or /msg bot !meteo [-d] [aide] [prev] [lng] <ville,tat> [pays]
# 	"-d" pour mettre un argument par dfaut pour l'utilisateur. 
#	"prev" pour les prvisions mto.
#	"lng" mettez ici la langue que vous voulez (us, fr, uk, es, br, de,...)

# Si vous voulez une ville en allemagne, france, us, uk,... et si le script est
# par dfaut dans une autre langue, vous devrier tapez :.wz lng ville (o lng
# est le pays de la ville). Par exemple : .wz fr nanterre va afficher en franais
# le rsultat pour la ville de "nanterre", ce que vous n'aurez par si votre langue
# par defaut est "us"...
#
# En cas de problme tapez : !meteo debug <description rapide du prob>
# Le script gnrera un fichier que vous devrez ensuite m'envoyeer par mail.
#
# Comme l'ensemble de mes scripts (ou presque) ce script est compatible
# avec Eggdrop et Windrop (et normalement tous les portages possibles).
#
# Historique :
#-------------
# v0.739 (20 january 2004)
# * Correction html pour la langue us
# * Correction des prvisions
# * Pas de nouvelles version utilisant le xml pour le moment... dsol
#
# v0.738 (5 juin 2004)
# * Changement dans la langue us
# * problemes etrange avec l'allemagne...
# * Divers commentaires dans les pages html de weather.com essayent 
# d'empecher ce genre de scripts...  nous allons donc suivre leurs 
# recommandations et la prochaine version de ce script utilisera
# le fichier xml. (dans moins d'un mois...)
#
# v0.737 (18 juin 2003)
# * Le mme bug, mais pour les prvisions.
#
# v0.736 (16 juin 2003)
# * Bug  cause d'une redirection dans le html
#
# v0.735 (2 juin 2003)
# * Bug dans les prvisions
#
# v0.734 (31 mai 2003)
# * Je pense que je devrais dormir un peu... (bug by me)
#
# v0.733 (29 mai 2003)
# * J'espere que c'est le dernier bug ;)
#
# v0.732 (25 mai 2003)
# * Des nouveaux bugs corrigs
#
# v0.731 (23 mai 2003)
# * Petit problme d'une page de redirection... Plus maintenant...
#  (Il s'agit uniquement d'une solution temporaire... Une nouvelle version
# sortira d'ici peu...)
#
# V0.73 (28 fvrier 2003)
# * Possibilit de choisir entre www.weather.com et www.wunderground.com
# * Ajout par la mme occasion de nouvelles langues (de l'afrikaans au yiddish)
#	il y a donc maintenant 60 langues!
# * Correction d'un bug ds l'url US
# * Mises  jour dans la procdure d'auto-update
#
# V0.723 (17 fvrier 2003)
# * Des bugs dans diffrentes langues
# * Changements dans le fichier de debug
#
# V0.722 (5 fvrier 2003)
# * Quelques changements ds le code http
# * Changement dans le code html uk
#
# V0.721 (28 janvier 2003)
# * Plus de bug si la langue est incorrecte.
# * Quelques changement dans le code de mise  jour.
# * Correction du bug pour mettre la ville par dfaut
#
# V0.72 (22 janvier 2003)
# * Petit changement dans le code html de la version us (encore...)
#
# V0.71 (10 janvier 2003)
# * Petit changement dans le code html de la version uk
#
# V0.7 (9 janvier 2003)
# * Possibilit de mise  jour directement  partir du script (!update) avec
#     rcupration de la configuration.
# * Correction de quelques bugs...
#
# V0.657 (8 janvier 2003)
# * Pareil, un changement ds le code html du site US
# * Le script gre maintenant les tempratures ngatives
# * Bonne anne :)
#
# V0.656 (23 novembre 2002)
# * Encore un changement du code html de la version US du site...
#
# V0.655 (10 septembre 2002)
# * Petit changement dans le code html du site...
#
# V0.654 (10 aot 2002)
# * Traduction de l'aide en allemand par Binzi
#
# V0.653 (16 juillet 2002)
# * Un ptit bug du site... (redirection trange...)
#
# V0.652 (20 juin 2002)
# * J'espre que ce coup ci c bon
#
# V0.651 (19 juin 2002)
# * un petit bug :)
#
# V0.65 (19 juin 2002)
# * Correction de bugs... (merci  McGuyver, Tommy Dool, Thornes, Aser,... pour 
# m'avoir envoyer les bugs :)
# * Ajout d'un redirecteur en cas de pages avec redirection (erreur 301 & 302)
#
# V0.64 (15 juin 2002)
# * Le site a chang du code HTML
# * Possibilit de voir dans les rsultats en C et F (pour toutes les langues) 
#  et aussi en km/h et mph (pour la us seulement).
#
# vx.xx (Quelques autres versions, mais aprs l'historique devient vraiment trop long...)
#
# V0.5B
# * Premiere version publique
#
# Projets :
#----------
# * Afficher la mto dtaill pour le jour que l'on veut.
# * Pouvoir grer d'autres sites
# * Capacit d'adaptation lors de changement de code html


# ======================================================================
# Ce programme est sous la licence GNU GPL v2 de la FSF.
# This script is under the GNU General Public License v2 of the FSF
# ------------------------------------------------------------------------
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; version 2 of the License.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# ------------------------------------------------------------------------
# En rsumer vous pouvez faire ce que vous voulez de ce script tant
# que vous prcisez l'auteur original donc Ycarus et que vous le laissez sous
# la licence GNU v2 de la FSF.

#----------------
# Configuration :
#----------------
# .debconf
# .notice Some html change for US language and forecast
set iws(lang) "fr"; # rgler ici la langue par dfaut : fr,us, uk, br, es ou de. - Default language. (set this to "us" for weather of the USA in english)
set iws(allowdefuser) "1"; # Pour autoriser les utilisateurs  rgler une ville par dfaut - To set if user can save a default city ("1" for on)
set iws(trigger) "!"; # The charactre juste avant la commande. "" marche galement. - The char before the cmd.
set iws(tmpfile) "tmpweatherinfo.txt"; # Le fichier temporaire - The temporary file
set iws(debugfile) "debugiwsfile.txt"; # Le fichier en cas de bugs - The file if there is a bug...
set iws(alwaysdebugon) "0"; # gnre toujours le rapport de bug - Make always the file of bug even if there is no bugs...

set iws(celsiusfahrenheitandkmhmph) "1"; # pour afficher  la fois les C, F, mph et km/h -  To display at the same time C, F, mph and km/h
# To set how we can display the result (\002 = Bold), For the actual weather (%var% = variable; word = word that change for every lnaguages)
# You can use %botnick% to put the nick of the bot.
#"\002 ---===> Weather Service <===---\002"
set iws(displaylook) {"\002 Weather %nameofcity%: \002 %weather%, %temp%C  \002Wind : \002 %vent%" "\002 Humidity: \002 %humidite% \002Barometer: \002 %pression%. "}
# Ce second look est utilis pour le site wunderground
# This look is for wunderground
set iws(displaylookwu) {"\002 Weather %nameofcity%: \002 %weather%, %temp%C  \002Wind : \002 %vent%" "\002 Humidity: \002 %humidite% \002Barometer: \002 %pression%."}
# It's the same but for the forecast weather.
set iws(displaylookpre) {"\002 Forecast %nameofcity%:\002" "%weather1%" "%weather2%" "%weather3%"}
# The separator between days for the forecast weather.
set iws(dayseparator) "-"

# Here you can but for what chan this script work (you can put "*" for all chan, don't forget the " " after the channel name :)
# Rglez ici les channels pour lesquelles ce script marche. Vous pouvez mettre '*' pour tous les chans.
set iws(activeon) "*"

# Here you put the channel where the result is in notice (don't forget the " " after the channel name :) You can also put "*"
# Pour que le rsultat soit afficher en 'notice'. Vous pouvez aussi mettre "*" pour tous les chans.
set iws(notice) "#oparus "


# Here you put the channel where the result is on the chan (don't forget the " " after the channel name :) You can also put "*"
# Pour que le rsultat soit afficher sur le chan. Vous pouvez aussi mettre "*" pour tous les chans.
set iws(channel) "#zugaina "

# Here you put the channel where the result is in private (don't forget the " " after the channel name :) You can also put "*"
# Pour que le rsultat soit afficher en 'private', Vous pouvez aussi mettre "*" pour tous les chans.
set iws(pv) "#actu "

set iws(scriptpath) "scripts/"; # Path of the script.

# Here you set the default site for weather
# Ici vous rglez le site par dfaut pour la mteo
# 0 = weather.com - 1 = wunderground.com
set iws(defsite) "0"

# .endconf
# Here you can change the link where you can auto update the script.
# Ici vous pouvez changer le liens o le script se met  jour automatiquement.
set iwsupdate(lnk) "http://yews.zugaina.org/scripts/"; # Only the link, without any filename.
set iwsupdate(filename) "meteo"; # Only the name, without any extension.


#---------------------------------------
# Dbut du script - Start of the script
#---------------------------------------
# You MUST have http.tcl - Vous DEVEZ avoir http.tcl (v2.x?)

package require http

set iws(ver) "0.739"

# The cmd of Weather v3.2 of Murf (For compatibility):
bind pub - .wz pub_iws
bind pub - .wzc pub_iws
bind pub - .wzf pub_previws
bind msg - .wz msg_iws
bind msg - .wzc msg_iws
bind msg - .wzf msg_previws
# pub cmd of this script (you can disable some of them) :
bind pub - ${iws(trigger)}10day pub_iws
bind pub - ${iws(trigger)}tenday pub_iws
bind pub - ${iws(trigger)}weather pub_iws
bind pub - ${iws(trigger)}wetter pub_iws
bind pub - ${iws(trigger)}meteo pub_iws
bind pub - ${iws(trigger)}previsions pub_previws
bind pub - ${iws(trigger)}prevision pub_previws
bind pub - ${iws(trigger)}forecast pub_previws
# msg cmd of this script (you can disable some of them) :
bind msg - ${iws(trigger)}meteo msg_iws
bind msg - ${iws(trigger)}weather msg_iws
bind msg - ${iws(trigger)}wetter msg_iws
bind msg - ${iws(trigger)}previsions msg_previws
bind msg - ${iws(trigger)}prevision msg_previws
bind msg - ${iws(trigger)}forecast msg_previws
bind msg m ${iws(trigger)}update iws_auto_update
#--------------------------------------
proc msg_iws  { nick uhost handle arg } {
	set arg [check_string $arg]
	pub_iws $nick $uhost $handle $nick $arg
}

proc msg_previws  { nick uhost handle arg } {
	set arg [check_string $arg]
	pub_previws $nick $uhost $handle $nick $arg
}

proc pub_previws {nick uhost hand chan arg} {
	set arg [check_string $arg]
	set arg "prev $arg"
	pub_iws $nick $uhost $hand $chan $arg
}

proc pub_iws {nick uhost hand chan arg} {
	global iws numversion tcl_version tcl_platform token
	set confighttp [::http::config -useragent "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)"]
	set thedefsite $iws(defsite)
	set token ""
	set weatherlnk ""
	set txtiws ""
	set changelng ""
	set arg [check_string $arg]
	set iwsdisplayby "channel"
	if {$chan != $nick} {
		if {(![string match "*[string tolower $chan] *" [string tolower $iws(activeon)]] && $iws(activeon) != "*")} {
			putlog "Ask for weather on $chan by $nick, but script not active here"
			return 0
		}
		if {([string match "*[string tolower $chan] *" $iws(notice)] || $iws(notice) == "*")} {
			set iwsdisplayby "notice"
		}
		if {([string match "*[string tolower $chan] *" $iws(pv)] || $iws(pv) == "*")} {
			set iwsdisplayby "pv"
		}
		if {([string match "*[string tolower $chan] *" $iws(channel)] || $iws(channel) == "*")} {
			set iwsdisplayby "channel"
		}
		
	}
	# If you want to know when someone run this script :
	#putlog "Ask for weather by $nick for : $arg"
	
	# Procedures to put out all thinks we don't like :)
	proc virecharschiantsiws {s} {
		regsub -all -- \\\\ $s "" s
		regsub -all -- \\\[ $s "" s
		regsub -all -- \\\] $s "" s
		regsub -all -- \\\} $s "" s
		regsub -all -- \\\{ $s "" s
		regsub -all -- \\\" $s "" s
		if {[string first $s "\]"] == 0} { set s [string trimleft $s \]] }
		if {[string last $s "\["] == [expr [string length $s] - 1]} { set s [string trimright $s \[] }
		return $s
	}
	
	proc virehtmletrefoustrucnormaliws {s} {
		regsub -all -- "&eacute;" $s "" s
		regsub -all -- "&egrave;" $s "" s
		regsub -all -- "&quot;" $s "\"" s
		regsub -all -- "&amp;" $s "\&" s
		regsub -all -- "&nbsp;" $s " " s
		regsub -all -- "&#39;s" $s "" s
		return $s
	}
	# reset the language to default language
	set langiws $iws(lang)
	# for the debug script :
	set askuserfor "$arg"
	set iwsdebugon "0"
	set arg [string tolower $arg]
	set arg [virecharschiantsiws $arg]
	set prevmeteo "0"
	set displayhelp "0"
	if {([lindex $arg 0] == "-d" && $iws(allowdefuser) == "1")} {
		set arg [lrange $arg 1 end]
		setuser $hand XTRA iws.location $arg
	}
	# To display help
	if {([lindex $arg 0] == "help" || [lindex $arg 0] == "aide")} {
		set displayhelp "1"
	}
	# Only if you have a problem and want a debug file
	if {[lindex $arg 0] == "debug"} {
		set iwsdebugon "1"
		set arg [lrange $arg 1 end]
		if {$arg == ""} {
			set arg "paris france"
		}
	}
	# If there is something in default
	if {[string length $arg] == 0} {
		if {[validuser $hand] && $iws(allowdefuser) == 1} {
			set arg [getuser $hand XTRA iws.location]
		}
	}
	#If you want an other site than the default one
	if {[lindex $arg 0] == "wu"} {
		set thedefsite "1"
		set arg [lrange $arg 1 end]
	}
	if {[lindex $arg 0] == "we"} {
		set thedefsite "0"
		set arg [lrange $arg 1 end]
	}
	# To see forecast weather
	if {[lindex $arg 0] == "prev"} {
		set prevmeteo "1"
		set arg [lrange $arg 1 end]
	}
	# All the languages in the script
	set langues {
		"yiyiddish"
		"wewelsh"
		"vivietnamese"
		"usamericanamericain"
		"ukrukrainian"
		"ukenglishgbanglais"
		"turturkmen"
		"tuturkish"
		"ththai"
		"tatagalog"
		"sweswedish"
		"swiswiss"
		"swswahili"
		"sloslovenian"
		"slslovak"
		"seserbian"
		"rurussian"
		"roromanian"
		"porportugueseportugais"
		"popolish"
		"ococcitan"
		"nonorwegiannorvegien"
		"malmaltese"
		"mamacedonian"
		"lilithuanian"
		"latlatvian"
		"lalatin"
		"kokoreancoren"
		"javjavanese"
		"jajapjaponesejaponais"
		"ititalianitalien"
		"gagaelic"
		"inindonesian"
		"idido"
		"icicelandic"
		"huhungarian"
		"hehebrew"
		"grgreekgrec"
		"gegeorgian"
		"gagalician"
		"frfrenchfranais"
		"fifinnish"
		"fafarsi"
		"estestonian"
		"espesperanto"
		"esspanishespanol"
		"dudutch"
		"dedeutschgermanallemand"
		"dadanish"
		"czczech"
		"crcroatian"
		"chchinesechinois"
		"cacatalan"
		"brbresilian"
		"bubulgarian"
		"bebelarussian"
		"babasque"
		"azazerbaijani"
		"ararabic"
		"alalbanian"
		"afafrikaans"
	}
	
	foreach {lng} $langues {
		set lng [split $lng ""]
		if {[lsearch $lng [lindex $arg 0]] != "-1"} {
			set langiws [lindex $lng 0]
			set arg [lrange $arg 1 end]
			break
		}
	}
	
	# pour les prvisions mto - For weather forecast :
	if {[lindex $arg 0] == "prev"} {
		set prevmeteo "1"
		set arg [lrange $arg 1 end]
	}
	
	regsub -all -- " " $arg "%20" arg
	# All language and strings
	if {($langiws == "af" || $langiws == "afrikaans")} {
		set thedefsite "1"
		set weatherlnk "http://afrikaans.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Kondisies"
			"C"
			"Wind"
			"Humiditeit"
			"Druk"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "al" || $langiws == "albanian")} {
		set thedefsite "1"
		set weatherlnk "http://albanian.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Kushtet"
			"F"
			"Era"
			"Lageshtira E ajrit"
			"Presioni"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "ar" || $langiws == "arabic")} {
		set thedefsite "1"
		set weatherlnk "http://arabic.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Weather"
			"F"
			"Wind"
			"Humidity"
			"Barometer"
			"Sun Index"
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "az" || $langiws == "azerbaijani")} {
		set thedefsite "1"
		set weatherlnk "http://azerbaijani.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Weather"
			"F"
			"Wind"
			"Humidity"
			"Barometer"
			"Sun Index"
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "ba" || $langiws == "basque")} {
		set thedefsite "1"
		set weatherlnk "http://azerbaijani.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Zirkunstantziak"
			"F"
			"Haizea"
			"Afoinua"
			"Presioa"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "be" || $langiws == "belarusian")} {
		set thedefsite "1"
		set weatherlnk "http://belarusian.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Weather"
			"F"
			"Wind"
			"Humidity"
			"Barometer"
			"Sun Index"
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "bu" || $langiws == "bulgarian")} {
		set thedefsite "1"
		set weatherlnk "http://bulgarian.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Weather"
			"F"
			"Wind"
			"Humidity"
			"Barometer"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {$langiws == "br"} {
		set thedefsite "0"
		set weatherlnk "http://br.weather.com/search/search?what=WeatherLocalUndeclared&where=$arg"
		# If someone can translate this I will be really happy :)
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Condies Atuais"
			"C"
			"Vento"
			"Umidade"
			"Barmetro"
			"ndice UV"
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "ca" || $langiws == "catalan")} {
		set thedefsite "1"
		set weatherlnk "http://catalan.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Condicions"
			"F"
			"Vent"
			"Humitat"
			"Pressi"
			""
			"Mnima"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "ch" || $langiws == "chinese")} {
		set thedefsite "1"
		set weatherlnk "http://simplifiedchinese.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Weather"
			"F"
			"Wind"
			"Humidity"
			"Barometer"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "cr" || $langiws == "croatian")} {
		set thedefsite "1"
		set weatherlnk "http://croatian.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Stanje"
			"F"
			"Vjetar"
			"Vl.zraka"
			"Pritisak"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "cz" || $langiws == "czech")} {
		set thedefsite "1"
		set weatherlnk "http://czech.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Stav"
			"F"
			"Vitr"
			"Vlhkost"
			"Tlak"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "da" || $langiws == "danish")} {
		set thedefsite "1"
		set weatherlnk "http://danish.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Forhold"
			"F"
			"Vind"
			"Luftfugtighed"
			"Tryk"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "du" || $langiws == "dutch")} {
		set thedefsite "1"
		set weatherlnk "http://simplifiedchinese.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Weerbeeld"
			"F"
			"Wind"
			"Vochtigheid"
			"Luchtdruk"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "esp" || $langiws == "esperanto")} {
		set thedefsite "1"
		set weatherlnk "http://esperanto.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Kondioj"
			"F"
			"Vento"
			"Humideco"
			"Aerpremo"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "est" || $langiws == "estonian")} {
		set thedefsite "1"
		set weatherlnk "http://estonian.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Ilmaolud"
			"F"
			"Tuul"
			"huniiskus"
			"hurhk"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "fa" || $langiws == "farsi")} {
		set thedefsite "1"
		set weatherlnk "http://farsi.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Weather"
			"F"
			"Wind"
			"Humidity"
			"Barometer"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "fi" || $langiws == "finnish")} {
		set thedefsite "1"
		set weatherlnk "http://finnish.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Solot"
			"F"
			"Tuuli"
			"Ilman kosteus"
			"Ilmanpaine"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "ga" || $langiws == "galician")} {
		set thedefsite "1"
		set weatherlnk "http://galician.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Condicins"
			"F"
			"Vento"
			"Humidade"
			"Presin"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "ge" || $langiws == "georgian")} {
		set thedefsite "1"
		set weatherlnk "http://georgian.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Weather"
			"F"
			"Wind"
			"Humidity"
			"Barometer"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "gr" || $langiws == "greek")} {
		set thedefsite "1"
		set weatherlnk "http://greek.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Weather"
			"F"
			"Wind"
			"Humidity"
			"Barometer"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	
	if {($langiws == "he" || $langiws == "hebrew")} {
		set thedefsite "1"
		set weatherlnk "http://hebrew.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Weather"
			"F"
			"Wind"
			"Humidity"
			"Barometer"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "hu" || $langiws == "hungarian")} {
		set thedefsite "1"
		set weatherlnk "http://hungarian.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Viszonyok"
			"F"
			"Szl"
			"Pratartalom"
			"Lgnyoms"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "ic" || $langiws == "icelandic")} {
		set thedefsite "1"
		set weatherlnk "http://icelandic.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Veurlsing"
			"F"
			"Vindur"
			"Raki"
			"Loftrstingur"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "id" || $langiws == "ido")} {
		set thedefsite "1"
		set weatherlnk "http://ido.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Cirkonstanci"
			"F"
			"Vento"
			"Humideso"
			"Presuro"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "in" || $langiws == "indonesian")} {
		set thedefsite "1"
		set weatherlnk "http://indonesian.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Kondisi"
			"F"
			"Angin"
			"Kelembaban"
			"Tekanan"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "ga" || $langiws == "gaelic")} {
		set thedefsite "1"
		set weatherlnk "http://gaelic.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Dla Aimsire"
			"F"
			"Gaoth"
			"Taise"
			"Br"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "it" || $langiws == "italian")} {
		set thedefsite "1"
		set weatherlnk "http://italian.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Condizioni"
			"F"
			"Vento"
			"Umidit"
			"Pressione"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "ja" || $langiws == "japanese")} {
		set thedefsite "1"
		set weatherlnk "http://nihongo.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Weather"
			"F"
			"Wind"
			"Humidity"
			"Barometer"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	
	if {($langiws == "jav" || $langiws == "javanese")} {
		set thedefsite "1"
		set weatherlnk "http://javanese.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Kahanan"
			"F"
			"Angin"
			"Kelembaban"
			"Tekanan"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "ko" || $langiws == "korean")} {
		set thedefsite "1"
		set weatherlnk "http://korean.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Weather"
			"F"
			"Wind"
			"Humidity"
			"Barometer"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "la" || $langiws == "latin")} {
		set thedefsite "1"
		set weatherlnk "http://latin.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Tempestas"
			"F"
			"Ventus"
			"Umor"
			"Pressio"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "lat" || $langiws == "latvian")} {
		set thedefsite "1"
		set weatherlnk "http://latvian.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Apstki"
			"F"
			"Vj"
			"Mitrums"
			"Spiediens"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "li" || $langiws == "lithuanian")} {
		set thedefsite "1"
		set weatherlnk "http://lithuanian.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Salygos"
			"F"
			"Vejas"
			"Dregme"
			"Slegis"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "ma" || $langiws == "macedonian")} {
		set thedefsite "1"
		set weatherlnk "http://macedonian.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Weather"
			"F"
			"Wind"
			"Humidity"
			"Barometer"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "mal" || $langiws == "maltese")} {
		set thedefsite "1"
		set weatherlnk "http://maltese.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Weather"
			"F"
			"Wind"
			"Humidity"
			"Barometer"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	
	if {($langiws == "no" || $langiws == "norwegian")} {
		set thedefsite "1"
		set weatherlnk "http://norwegian.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Forhold"
			"F"
			"Vind"
			"Fuktighet"
			"Trykk"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "oc" || $langiws == "occitan")} {
		set thedefsite "1"
		set weatherlnk "http://occitan.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Condicions"
			"F"
			"vent"
			"Imor"
			"Pression"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "po" || $langiws == "polish")} {
		set thedefsite "1"
		set weatherlnk "http://polish.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Warunki pogodowe"
			"F"
			"Wiatr"
			"Wilgotnosc"
			"Cisnienie"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "por" || $langiws == "portuguese")} {
		set thedefsite "1"
		set weatherlnk "http://portuguese.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Condies"
			"F"
			"Vento"
			"Humidade"
			"Presso"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "ro" || $langiws == "romanian")} {
		set thedefsite "1"
		set weatherlnk "http://romanian.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Weather"
			"F"
			"Wind"
			"Humidity"
			"Barometer"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "ru" || $langiws == "russian")} {
		set thedefsite "1"
		set weatherlnk "http://russian.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Weather"
			"F"
			"Wind"
			"Humidity"
			"Barometer"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "se" || $langiws == "serbian")} {
		set thedefsite "1"
		set weatherlnk "http://serbian.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Uslovi"
			"F"
			"Vetar"
			"Vlaznost"
			"Pritisak"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "sl" || $langiws == "slovak")} {
		set thedefsite "1"
		set weatherlnk "http://slovak.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Stav pocasia"
			"F"
			"Vietor"
			"Vlhkost"
			"Tlak"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "slo" || $langiws == "slovenian")} {
		set thedefsite "1"
		set weatherlnk "http://slovenian.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Razmere"
			"F"
			"Veter"
			"Vlaga"
			"Pritisk"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "sw" || $langiws == "swahili")} {
		set thedefsite "1"
		set weatherlnk "http://swahili.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Hali ilivyo"
			"F"
			"Upepo"
			"Unyevu"
			"Shinikizo"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "swe" || $langiws == "swedish")} {
		set thedefsite "1"
		set weatherlnk "http://swedish.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Frhllanden"
			"F"
			"Vind"
			"Fuktighet"
			"Lufttryck"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "swi" || $langiws == "swiss")} {
		set thedefsite "1"
		set weatherlnk "http://swiss.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Bedingige"
			"F"
			"Wind"
			"Fechtigkait"
			"Drugg"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "ta" || $langiws == "tagalog")} {
		set thedefsite "1"
		set weatherlnk "http://tagalog.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Kondisyon"
			"F"
			"Hangin"
			"Humidito"
			"Pwersa"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "th" || $langiws == "thai")} {
		set thedefsite "1"
		set weatherlnk "http://thai.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Weather"
			"F"
			"Wind"
			"Humidity"
			"Barometer"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	
	if {($langiws == "tu" || $langiws == "turkish")} {
		set thedefsite "1"
		set weatherlnk "http://turkish.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Weather"
			"F"
			"Wind"
			"Humidity"
			"Barometer"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "tur" || $langiws == "turkmen")} {
		set thedefsite "1"
		set weatherlnk "http://turkmen.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Weather"
			"F"
			"Wind"
			"Humidity"
			"Barometer"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	
	if {($langiws == "ukr" || $langiws == "ukrainian")} {
		set thedefsite "1"
		set weatherlnk "http://ukrainian.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Weather"
			"F"
			"Wind"
			"Humidity"
			"Barometer"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "vi" || $langiws == "vietnamese")} {
		set thedefsite "1"
		set weatherlnk "http://vietnamese.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Weather"
			"F"
			"Wind"
			"Humidity"
			"Barometer"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	
	if {($langiws == "we" || $langiws == "welsh")} {
		set thedefsite "1"
		set weatherlnk "http://welsh.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Amodau"
			"F"
			"Gwynt"
			"Lleithder"
			"Gwasgedd"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "yi" || $langiws == "yiddish")} {
		set thedefsite "1"
		set weatherlnk "http://yiddishtransliterated.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"tsushtand"
			"F"
			"vint"
			"faykhtkeyt"
			"druk"
			""
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {($langiws == "fr" || $langiws == "french")} {
		set langiws "fr"
		if {$thedefsite == "0"} {
			set weatherlnk "http://fr.weather.com/search/search?what=WeatherLocalUndeclared&where=$arg"
		} elseif {$thedefsite == "1"} {
			set weatherlnk "http://french.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		}
		set txtiws {
			"Veuillez prciser une ville. Tapez !meteo nomdelaville pays. (le nom du pays est requis si il y a plusieurs villes dans le monde avec le mme nom)."
			"La ville que vous demandez n'est pas disponible."
			"Le serveur de mto est surcharg."
			"Mto de"
			"C"
			"Vent"
			"Humidit"
			"Pression"
			"Indice UV"
			"mini"
			"Prvisions de"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {$langiws == "de"} {
	
		if {$thedefsite == "0"} {
			set weatherlnk "http://de.w3.weather.com/search/search?what=WeatherLocalUndeclared&where=$arg"
		} elseif {$thedefsite == "1"} {
			set weatherlnk "http://deutsch.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		}
		# Someone translated this and I'm really happy now ;)
		set txtiws {
			"Bitte geben Sie eine Stadt an (und das Land, sollte der Name der Stadt nicht eindeutig sein)."
			"Sorry, fuer die gesuchte Stadt liegen uns leider keine Wetterdaten vor."
			"Der Wetter-Server ist zur Zeit leider ueberlastet, bitte versuchen Sie es spaeter erneut."
			"Wetterlage"
			"C"
			"Wind"
			"Luftfeuchtigkeit"
			"Luftdruck"
			"UV-Index"
			"mini"
			"Wettervorhersage"
			"\002Syntax\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <Stadt,Staat|PLZ> \[Land\]."
			"\002-d\002 setzt eine Stadt als Standard, deren Wetterlage ab dann mit der Eingabe von !weather abgerufen werden kann. \002prev\002 Zeigt die Wettervorhersage der naechsten Tage an. \002lng\002 Legt die gewuenschte Sprache fest (us, fr, uk, es, br, de). Setzen Sie 'lng' auf das Land der entsprechenden Stadt, um Ihr Suchergebnis zu verbessern."
		}
	}
	if {$langiws == "uk"} {
		if {$thedefsite == "0"} {
			set weatherlnk "http://uk.weather.com/search/search?what=WeatherLocalUndeclared&where=$arg"
		} elseif {$thedefsite == "1"} {
			set weatherlnk "http://english.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		}
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Weather"
			"C"
			"Wind"
			"Humidity"
			"Barometer"
			"Sun Index"
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {$langiws == "us"} {
		if {$thedefsite == "0"} {
			set weatherlnk "http://www.weather.com/search/search?what=WeatherLocalUndeclared&where=$arg"
		} elseif {$thedefsite == "1"} {
			set weatherlnk "http://www.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		}
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Weather"
			"F"
			"Wind"
			"Humidity"
			"Barometer"
			"Sun Index"
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}

	if {$langiws == "es"} {
		if {$thedefsite == "0"} {
			set weatherlnk "http://espanol.weather.com/search/search?what=WeatherLocalUndeclared&where=$arg"
		} elseif {$thedefsite == "1"} {
			set weatherlnk "http://espanol.wunderground.com/cgi-bin/findweather/getForecast?query=$arg"
		}
		# If someone can translate this I will be really happy :)
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Condiciones actuales"
			"C"
			"Viento"
			"Humedad relativa"
			"Barmetro"
			"ndice UV"
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
	}
	if {$displayhelp == "1"} {
		putserv "PRIVMSG $nick : [lindex $txtiws 11]"
		putserv "PRIVMSG $nick : [lindex $txtiws 12]"
		return 0
	}
	# There is no arg....
	if {[string length $arg] == 0} {
		putserv "PRIVMSG $nick : [lindex $txtiws 0]"
		return 0
	}
	# For user who can't put correctly the language of the script...
	if {($weatherlnk == "" || $langiws == "" || $txtiws == "")} {
		set langiws "us"
		set thedefsite "0"
		set weatherlnk "http://www.weather.com/search/search?what=WeatherLocalUndeclared&where=$arg"
		set txtiws {
			"Please put the name of a city (and the country if there is some other city with the same name)."
			"Sorry we don't have the weather of the city you ask for."
			"Too many traffic on the weather server."
			"Weather"
			"F"
			"Wind"
			"Humidity"
			"Barometer"
			"Sun Index"
			"mini"
			"Forecast Weather"
			"\002Usage\002: !weather \[-d\] \[prev\] \[lng\]\[help\] <city,state|zip> \[country\]."
			"\002-d\002 will set a default allowing user to just type !weather. \002prev\002 for forecast weather. \002lng\002 put here the language you want (us, fr, uk, es, br, de). The result can also be better if 'lng' is the country where the city is."
		}
		set changelng "3"
		putlog "You have a configuration error... Default language is now us !"
	}
	if {$thedefsite == "0"} {
#		set weatherlnk "$weatherlnk?&setcookie=1"
	}
	
	
	#putlog "le lien : $weatherlnk"
	if {$thedefsite == "0"} {
		set search1ok "0"
		set iwssearchcityok "0"
		while {$iwssearchcityok == "0"} {
			# search for the city name
			set erroronconnection "0"
			set connectionok "0"
			while {$connectionok == "0"} {
				#putlog "mteo : recherche ville"
				if { [catch {http::geturl $weatherlnk -timeout 30000} token] } {
					if { [catch {http::geturl $weatherlnk -timeout 20000} token] } {
						putlog "Problem when we want to connect to : $weatherlnk"
						if {[info exists token]} {
							set finishhttp [http::Finish $token]
						}
						return 0
					}
				}
				#set token [http::geturl $weatherlnk -timeout 30000]
				if {([::http::status $token] == "ok")} {
					#puts stderr ""
					upvar #0 $token state
					foreach {name value} $state(meta) {
						if {[regexp -nocase ^location$ $name]} {
							set weatherlnk "[string trim $value]"
						}
					}
					set connectionok "1"
				} {
					if {$erroronconnection == "1"} {
						if {[::http::status $token] == "timeout"} {
							#prob
							putserv "PRIVMSG $nick : Connection Timeout..."
							if {[info exists token]} {
								set finishhttp [http::Finish $token]
							}
							return 0
						} {
							putlog "Connection error... to : $weatherlnk"
							if {[info exists token]} {
								set finishhttp [http::Finish $token]
							}
							return 0
						}
					}
					set finishhttp [http::Finish $token]
					set erroronconnection "1"
				}
				if {[info exists token]} {
					set finishhttp [http::Finish $token]
				}
			}
			
			#putlog "le lien 1 : $weatherlnk"
			# There are more than one city...	
			if {[string match "*search*" $weatherlnk]} {
				#<a href="/weather/local/FRXX0076">Paris, France</a><br>
				# choix entre plusieurs.
				set tmpweatherinfo [http::data $token]
				if { [catch {open "$iws(tmpfile)" w} tmpweatherfile] } {
					putlog "The script can't write the file : $iws(tmpfile) (make sure you have all the corrects right or the path is ok...)"
					return 0
				}
				puts $tmpweatherfile $tmpweatherinfo
				close $tmpweatherfile
				set tmpweatherinfile [open "$iws(tmpfile)" r]
				set endfile "0"
				while {![eof $tmpweatherinfile] && $endfile == "0"} {
					gets $tmpweatherinfile poi
					set poi [string trim $poi]
					if {[string match "*<a href=\"/weather/local/*\">*</a><br>*" $poi]} {
						set endfile "1"
						set weatherlnk [string range [string trim $poi] [expr [string first "<a href=" $poi] + 9] [expr [string first "\">" $poi] - 1]]
						if {$langiws == "fr"} {
							set weatherlnk "http://fr.weather.com$weatherlnk"
						} elseif {$langiws == "de"} {
							set weatherlnk "http://de.w3.weather.com$weatherlnk"
						} elseif {$langiws == "uk"} {
							set weatherlnk "http://www.weather.co.uk$weatherlnk"
						} elseif {$langiws == "us"} {
							set weatherlnk "http://www.weather.com$weatherlnk"
							#?go=go&where=$arg&whatprefs="
						} elseif {$langiws == "br"} {
							set weatherlnk "http://br.weather.com$weatherlnk"
						} elseif {$langiws == "es"} {
							set weatherlnk "http://espanol.weather.com$weatherlnk"
						}
					}
					if {[string match "*Severe Weather Mode Index*" $poi]} {
						putserv "PRIVMSG $nick : Too many traffic on the server : There is a Weather Alert."
						close $tmpweatherinfile
						if {[info exists token]} {
							set finishhttp [http::Finish $token]
						}	
						return 0
					}
				}
				#exemple : http://fr.weather.com/weather/local/FRXX0076 (for Paris)
				close $tmpweatherinfile
			}
			set finishhttp [http::Finish $token]
			# We can't find the city...
			if {[string match "*search*" $weatherlnk]} {
				if {$search1ok == "1"} {
					putserv "PRIVMSG $nick : \002[lindex $txtiws 1]\002"
					return 0
				}
				if {[string match "*%20de*" $arg]} {
					set arg [string range [string trim $arg] 0 [expr [string first "%20" $arg] - 1]]
					set weatherlnk "http://de.w3.weather.com/search/search?what=WeatherLocalUndeclared&where=$arg"
					set langiws "de"
					set search1ok "1"
				} elseif {[string match "*%20es*" $arg]} {
					set arg [string range [string trim $arg] 0 [expr [string first "%20" $arg] - 1]]
					set weatherlnk "http://espanol.weather.com/search/search?what=WeatherLocalUndeclared&where=$arg"
					set langiws "es"
					set search1ok "1"
				} elseif {[string match "*%20br*" $arg]} {
					set arg [string range [string trim $arg] 0 [expr [string first "%20" $arg] - 1]]
					set weatherlnk "http://br.weather.com/search/search?what=WeatherLocalUndeclared&where=$arg"
					set langiws "br"
					set search1ok "1"
				} elseif {[string match "*%20uk*" $arg]} {
					set arg [string range [string trim $arg] 0 [expr [string first "%20" $arg] - 1]]
					set weatherlnk "http://www.weather.co.uk/search/search?what=WeatherLocalUndeclared&where=$arg"
					set langiws "uk"
					set search1ok "1"
				} elseif {[string match "*%20fr*" $arg]} {
					set arg [string range [string trim $arg] 0 [expr [string first "%20" $arg] - 1]]
					set weatherlnk "http://fr.weather.com/search/search?what=WeatherLocalUndeclared&where=$arg"
					set langiws "fr"
					set search1ok "1"
				} elseif {[string match "*%20us*" $arg]} {
					set arg [string range [string trim $arg] 0 [expr [string first "%20" $arg] - 1]]
					set weatherlnk "http://www.weather.com/search/search?what=WeatherLocalUndeclared"
					set langiws "us"
					set search1ok "1"
					set changelng "2"
				} {
					putserv "PRIVMSG $nick : \002[lindex $txtiws 1]\002"
					return 0
				}
			} {
				set iwssearchcityok "1"
			}
			# A weather alert or too many users.
			if {[string match "*newscenter*" $weatherlnk]} {
				putserv "PRIVMSG $nick : \002[lindex $txtiws 2]\002"
				return 0
			}
		}
	} elseif {$thedefsite == "1"} {
	
		set search1ok "0"
		set iwssearchcityok "0"
		while {$iwssearchcityok == "0"} {
			# search for the city name
			set erroronconnection "0"
			set connectionok "0"
			while {$connectionok == "0"} {
				#putlog "mteo : recherche ville"
				if { [catch {http::geturl $weatherlnk -timeout 30000} token] } {
					if { [catch {http::geturl $weatherlnk -timeout 20000} token] } {
						putlog "Problem when we want to connect to : $weatherlnk"
						if {[info exists token]} {
							set finishhttp [http::Finish $token]
						}
						return 0
					}
				}
				#set token [http::geturl $weatherlnk -timeout 30000]
				if {([::http::status $token] == "ok")} {
					#puts stderr ""
					upvar #0 $token state
					foreach {name value} $state(meta) {
						if {[regexp -nocase ^location$ $name]} {
							set weatherlnk "[string trim $value]"
						}
					}
					set connectionok "1"
				} {
					if {$erroronconnection == "1"} {
						if {[::http::status $token] == "timeout"} {
							#prob
							putserv "PRIVMSG $nick : Connection Timeout..."
							if {[info exists token]} {
								set finishhttp [http::Finish $token]
							}
							return 0
						} {
							putlog "Connection error... to : $weatherlnk"
							if {[info exists token]} {
								set finishhttp [http::Finish $token]
							}
							return 0
						}
					}
					set finishhttp [http::Finish $token]
					set erroronconnection "1"
				}
			}
			
			#putlog "le lien 1 : $weatherlnk"
			# There are more than one city...	
			if {[string match "*query*" $weatherlnk]} {
				# choix entre plusieurs.
				set tmpweatherinfo [http::data $token]
				if { [catch {open "$iws(tmpfile)" w} tmpweatherfile] } {
					putlog "The script can't write the file : $iws(tmpfile) (make sure you have all the corrects right or the path is ok...)"
					return 0
				}
				puts $tmpweatherfile $tmpweatherinfo
				close $tmpweatherfile
				set tmpweatherinfile [open "$iws(tmpfile)" r]
				set endfile "0"
				while {![eof $tmpweatherinfile] && $endfile == "0"} {
					gets $tmpweatherinfile poi
					set poi [string trim $poi]
					#<tr bgcolor=#FFFFFF><td><a href="/US/ME/Paris.html">Paris, Maine</a></td><td>
					if {[string match "*<tr bgcolor=*<td><a href=*>*</a></td><td>*" $poi]} {
						set endfile "1"
						set prevweathlnk [string range [string trim $weatherlnk] [string first "http://" $weatherlnk] [expr [string first "cgi-bin" $weatherlnk] - 2]]
						set weatherlnk [string range [string trim $poi] [expr [string first "<a href=" $poi] + 9] [expr [string first "\">" $poi] - 1]]
						set weatherlnk "$prevweathlnk$weatherlnk"
					}
					if {[string match "*Search not found:*" $poi]} {
						putserv "PRIVMSG $nick : \002[lindex $txtiws 1]\002"
						return 0
					}
				}
				close $tmpweatherinfile
			}
			set finishhttp [http::Finish $token]
			set iwssearchcityok "1"
		}
	}
	# For weather forecast :
	if {$prevmeteo == "1"} {
		if {$thedefsite == "0"} {
			#http://fr.weather.com/weather/tenday/FRXX0076?day=0&vert=WeatherCity
			regsub -all -- "local" $weatherlnk "tenday" weatherlnk
			if {$langiws == "uk"} {
				set weatherlnk "$weatherlnk?day=0&amp;vert=WeatherCity"
			} {
				set weatherlnk "$weatherlnk?day=0&vert=WeatherCity"
			}
		}
		set erroronconnection "0"
		set connectionok "0"
		while {$connectionok == "0"} {
			#set token [http::geturl $weatherlnk -timeout 10000]
			if { [catch {http::geturl $weatherlnk -timeout 30000} token] } {
				if { [catch {http::geturl $weatherlnk -timeout 20000} token] } {
					putlog "Problem when we want to connect to : $weatherlnk"
					if {[info exists token]} {
						set finishhttp [http::Finish $token]
					}
					return 0
				}
			}
		# If there is redirect error (301 or 302) by Neil Madden.
			while {([http::ncode $token] == 301) || ([http::ncode $token] == 302)} {
				upvar #0 $token state
				array set meta $state(meta)
				http::cleanup $token
				set token [http::geturl $meta(Location)]
			}
			if {([::http::status $token] == "ok")} {
				set weatherinfo [http::data $token]
				set finishhttp [http::Finish $token]
				set connectionok "1"
			} {
				if {$erroronconnection == "1"} {
					if {[::http::status $token] == "timeout"} {
						#prob
						putserv "PRIVMSG $nick : Connection Timeout..."
						if {[info exists token]} {
							set finishhttp [http::Finish $token]
						}
						return 0
					} {
						putlog "Connection error... to : $weatherlnk"
						if {[info exists token]} {
							set finishhttp [http::Finish $token]
						}
						return 0
					}
				}
				set finishhttp [http::Finish $token]
				set erroronconnection "1"
			}
		}
		if {$thedefsite == "0"} {
			
			set weatherinfo [http::data $token]
			#puts stderr ""
			upvar #0 $token state
			foreach {name value} $state(meta) {
				if {[regexp -nocase ^location$ $name]} {
					set weatherlnk "[string trim $value]"
				}
			}
			# A weather alert or too many users.
			if {[string match "*newscenter*" $weatherlnk]} {
				putserv "PRIVMSG $nick : [lindex $txtiws 2]"
				if {[info exists token]} {
					set finishhttp [http::Finish $token]
				}
				return 0
			}
			set finishhttp [http::Finish $token]
			set weatherfile [open "$iws(tmpfile)" w]
			puts $weatherfile $weatherinfo
			close $weatherfile
			set weatherinfile [open "$iws(tmpfile)" r]
			set finfichier "0"
			while {![eof $weatherinfile] || $finfichier == "0"} {
				gets $weatherinfile poi
				set poi [string trim $poi]
				if {[string match -nocase "*meta http-equiv=\"Refresh\" content=\"*;URL=*\">*" $poi]} {
					set weatherlnk [string range [string trim $poi] [expr [string last "URL=" $poi] + 4] [expr [string first ">" $poi] - 2]]
					set erroronconnection "0"
					set connectionok "0"
					set redirection "0"
					while {$connectionok == "0"} {
						#set token [http::geturl $weatherlnk -timeout 10000]
						if { [catch {http::geturl $weatherlnk -timeout 30000} token] } {
							if { [catch {http::geturl $weatherlnk -timeout 20000} token] } {
								putlog "Problem when we want to connect to : $weatherlnk"
								if {[info exists token]} {
									set finishhttp [http::Finish $token]
								}
								return 0
							}
						}
						# If there is redirect error (301 or 302) by Neil Madden.
						while {([http::ncode $token] == 301) || ([http::ncode $token] == 302)} {
							upvar #0 $token state
							array set meta $state(meta)
							http::cleanup $token
							set token [http::geturl $meta(Location)]
							set redirection "1"
						}
						if {([::http::status $token] == "ok")} {
							set weatherinfo [http::data $token]
							set finishhttp [http::Finish $token]
							set connectionok "1"
						} {
							if {$erroronconnection == "1"} {
								if {[::http::status $token] == "timeout"} {
									#prob
									putserv "PRIVMSG $nick : Connection Timeout..."
									if {[info exists token]} {
										set finishhttp [http::Finish $token]
									}
									return 0
								} {
									putlog "Connection error... to : $weatherlnk"
									if {[info exists token]} {
										set finishhttp [http::Finish $token]
									}
									return 0
								}
							}
							set finishhttp [http::Finish $token]
							set erroronconnection "1"
						}
					}
					close $weatherinfile
					set weatherfile [open "$iws(tmpfile)" w]
					puts $weatherfile $weatherinfo
					close $weatherfile
					set weatherinfile [open "$iws(tmpfile)" r]
					set finfichier "1"
				}
				if {[string match -nocase "*</head>*" $poi]} {
					set finfichier "1"
				}
			}
			close $weatherinfile
			set weatherinfile [open "$iws(tmpfile)" r]
			set prevtotal ""
			set nameofcitynear "0"
			set nameofcity ""
			set tempmax ""
			set tempmini ""
			set meteoprob ""
			set weather ""
			while {![eof $weatherinfile]} {
				gets $weatherinfile poi
				set poi [string trim $poi]
				if {$nameofcitynear == "1"} {
					set nameofcitynear "0"
					set nameofcity "$poi"
				}
				 
				if {([string match -nocase "*<img SRC=\"http://image.weather.com/web/blank.gif\" WIDTH=\"5\" HEIGHT=\"1\" BORDER=\"0\" ALT=\"\">*" $poi] && $nameofcity == "")} {
					set nameofcitynear "1"
				}
				if {([string match -nocase "*<IMG SRC=\"http://image.weather.com/web/common/*\" WIDTH=\"31\" HEIGHT=\"31\" BORDER=\"0\" ALT=\"*\">*" $poi])} {
					set weather [string range [string trim $poi] [expr [string first "ALT=" $poi] + 5] [expr [string first ">" $poi] - 2]]
					set prevtotal "$prevtotal $weather"
		
				}
				# For us language
				if {$langiws == "us"} {
					if {[string match "*&deg;F" $poi]} {
						set temp [string range [string trim $poi] 0 [expr [string first "&deg;F" $poi] - 1]]
						if {$tempmax == ""} {
							set tempmax "$temp"
						} {
							set tempmini "$temp"
						}
					}
					if {[string match "*<BR>*" $poi]} {
						if {[string match "*</A><BR>*" $poi]} {
							set dayofmeteo [string range [string trim $poi] 0 [expr [string first "</A><BR>" $poi] - 1]]
							set nbandmonthofmeteo [string range [string trim $poi] [expr [string first "</A><BR>" $poi] + 8] [string length $poi]]
							if {$prevtotal == ""} {
								set prevtotal "$dayofmeteo $nbandmonthofmeteo :"
							} {
								if {$tempmini == ""} {
									if {($iws(celsiusfahrenheitandkmhmph) == "1" && [string is integer -strict $tempmax])} {
										set prevtotal "$prevtotal ([lindex $txtiws 9] : $tempmaxF/[expr (($tempmax - 32) * 10) / 18]C)  $dayofmeteo $nbandmonthofmeteo :"
									} {
										set prevtotal "$prevtotal ([lindex $txtiws 9] : $tempmaxF)  $dayofmeteo $nbandmonthofmeteo :"
									}	
								} {
									if {($iws(celsiusfahrenheitandkmhmph) == "1"  && [string is integer -strict $tempmax])} {
										set prevtotal "$prevtotal ($tempmaxF/[expr (($tempmax - 32) * 10) / 18]C-$tempminiF/[expr (($tempmini - 32) * 10) / 18]C)  $dayofmeteo $nbandmonthofmeteo :"
									} {
										set prevtotal "$prevtotal ($tempmaxF-$tempminiF)  $dayofmeteo $nbandmonthofmeteo :"
									}
								}
								set tempmax ""
								set tempmini ""
							}
						} {
							set dayofmeteo [string range [string trim $poi] 0 [expr [string first "<BR>" $poi] - 1]]
							set nbandmonthofmeteo [string range [string trim $poi] [expr [string first "<BR>" $poi] + 4] [string length $poi]]
							if {$prevtotal == ""} {
								set prevtotal "$dayofmeteo $nbandmonthofmeteo :"
							} {
								if {$tempmini == ""} {
									if {($iws(celsiusfahrenheitandkmhmph) == "1" && [string is integer -strict $tempmax])} {
										set prevtotal "$prevtotal ([lindex $txtiws 9] : $tempmaxF/[expr (($tempmax - 32) * 10) / 18]C)  $dayofmeteo $nbandmonthofmeteo :"
									} {
										set prevtotal "$prevtotal ([lindex $txtiws 9] : $tempmaxF)  $dayofmeteo $nbandmonthofmeteo :"
									}
								} {
									if {($iws(celsiusfahrenheitandkmhmph) == "1"  && [string is integer -strict $tempmax])} {
										set prevtotal "$prevtotal ($tempmaxF/[expr (($tempmax - 32) * 10) / 18]C-$tempminiF/[expr (($tempmini - 32) * 10) / 18]C)  $dayofmeteo $nbandmonthofmeteo :"
									} {
										set prevtotal "$prevtotal ($tempmaxF-$tempminiF)  $dayofmeteo $nbandmonthofmeteo :"
									}
								}
								set tempmax ""
								set tempmini ""
							}
						}
					}
			
				} {
					# for other language :
					if {[string match "*&deg;C*" $poi]} {
						set temp [string range [string trim $poi] 0 [expr [string first "&deg;C" $poi] - 1]]
						if {$tempmax == ""} {
							set tempmax "$temp"
						} {
							set tempmini "$temp"
						}
					}
					if {[string match "*</A><BR>*" $poi]} {
						set dayofmeteo [string range [string trim $poi] 0 [expr [string first "</A><BR>" $poi] - 1]]
						set nbandmonthofmeteo [string range [string trim $poi] [expr [string first "</A><BR>" $poi] + 8] [string length $poi]]
						if {$prevtotal == ""} {
							set prevtotal "$dayofmeteo $nbandmonthofmeteo : "
						} {
							if {$tempmini == ""} {
								if {($iws(celsiusfahrenheitandkmhmph) == "1" && [string is digit -strict $tempmax])} {
									set prevtotal "$prevtotal ([lindex $txtiws 9] : $tempmaxC/[expr ($tempmax * 1.8) + 32]F)  $dayofmeteo $nbandmonthofmeteo :"
								} {
									set prevtotal "$prevtotal ([lindex $txtiws 9] : $tempmaxC)  $dayofmeteo $nbandmonthofmeteo :"
								}
							} {
								if {($iws(celsiusfahrenheitandkmhmph) == "1" && [string is digit -strict $tempmax])} {
									set prevtotal "$prevtotal ($tempmaxC/[expr ($tempmax * 1.8) + 32]F-$tempminiC/[expr ($tempmini * 1.8) + 32]F)  $dayofmeteo $nbandmonthofmeteo :"
								} {
									set prevtotal "$prevtotal ($tempmaxC-$tempminiC)  $dayofmeteo $nbandmonthofmeteo :"
								}
							}
							set tempmax ""
							set tempmini ""
						}
					}
					if {[string match "*.<BR>*" $poi]} {
						set dayofmeteo [string range [string trim $poi] 0 [expr [string first "<BR>" $poi] - 1]]
						set nbandmonthofmeteo [string range [string trim $poi] [expr [string first "<BR>" $poi] + 4] [string length $poi]]
						if {$prevtotal == ""} {
							set prevtotal "$dayofmeteo $nbandmonthofmeteo : "
						} {
							if {$tempmini == ""} {
								if {($iws(celsiusfahrenheitandkmhmph) == "1" && [string is digit -strict $tempmax])} {
									set prevtotal "$prevtotal ([lindex $txtiws 9] : $tempmaxC/[expr ($tempmax * 1.8) + 32]F)  $dayofmeteo $nbandmonthofmeteo :"
								} {
									set prevtotal "$prevtotal ([lindex $txtiws 9] : $tempmaxC)  $dayofmeteo $nbandmonthofmeteo :"
								}
							} {
								if {($iws(celsiusfahrenheitandkmhmph) == "1" && [string is digit -strict $tempmax])} {
									set prevtotal "$prevtotal ($tempmaxC/[expr ($tempmax * 1.8) + 32]F-$tempminiC/[expr ($tempmini * 1.8) + 32]F)  $dayofmeteo $nbandmonthofmeteo :"
								} {
									set prevtotal "$prevtotal ($tempmaxC-$tempminiC)  $dayofmeteo $nbandmonthofmeteo :"
								}
							}
							set tempmax ""
							set tempmini ""
						}
					}
				}
			
			}
			close $weatherinfile
			
		} elseif {$thedefsite == "1"} {
			set weatherfile [open "$iws(tmpfile)" w]
			puts $weatherfile $weatherinfo
			close $weatherfile
			set weatherinfile [open "$iws(tmpfile)" r]
			set prevtotal ""
			set weather "0"
			set nameofcity ""
			set maxmin "0"
			set meteoprob ""
			set temp ""
			set countnb "0"
			while {![eof $weatherinfile]} {
				gets $weatherinfile poi
				set poi [string trim $poi]

				if {[string match -nocase "*b><font size=* color=#ffffff>*</font></b>*" $poi]} {
					set nameofcity [string range [string trim $poi] [expr [string last "ff>" $poi] + 3] [expr [string first "</font>" $poi] - 1]]
				}
				if {$maxmin == "1"} {
					set maxmin "$poi"
					
				}
				if {$weather == "1"} {
					set weather "$poi"
					set maxmin "1"
				}
				if {[string match -nocase "*<td align=left><b>*" $poi]} {
					set dayofmeteo [string range [string trim $poi] [expr [string last "<b>" $poi] + 3] [expr [string first "</b>" $poi] - 1]]
					set weather "1"
				}
				if {[string match -nocase "*&deg; *.*" $poi]} {
					set temptp [string range [string trim $poi] 0 [expr [string first "&deg" $poi] - 1]]
					if {$temp != ""} {
						set temp "$temptpC/$tempF"
						if {$countnb == "0"} {
							if {$prevtotal == ""} {
								set prevtotal "$dayofmeteo : $weather $maxmin ($temp)"
							} {
								set prevtotal "$prevtotal  $dayofmeteo : $weather $maxmin ($temp)"
							}
							set countnb "1"
						} {
							set countnb "0"
						}						
						set temp ""
						set dayofmeteo ""
						set maxmin "0"
						set weather "0"
					} {
						set temp "$temptp"
					}
				}
			}
		}
		if {[info exists token]} {
			set finishhttp [http::Finish $token]
		}
		# we display the result and we cut it in 3 parts
		set prevtotal [split $prevtotal ""]
		set weather1 [join [lrange $prevtotal 0 [expr ([llength $prevtotal] / 3)]]]
		set weather2 [join [lrange $prevtotal [expr [expr ([llength $prevtotal] / 3)] + 1] [expr (2 * [expr ([llength $prevtotal] / 3)])]]]
		set weather3 [join [lrange $prevtotal [expr [expr (2 * [expr ([llength $prevtotal] / 3)])] + 1] end]]
		regsub -all -- "   " $weather1 " $iws(dayseparator) " weather1
		regsub -all -- "   " $weather2 " $iws(dayseparator) " weather2
		regsub -all -- "   " $weather3 " $iws(dayseparator) " weather3
		set countelement "0"
		set prevweatherlook [putdisplayokpreviws $iws(displaylookpre) [lindex $txtiws 10] $nameofcity $weather1 $weather2 $weather3]
		while {$countelement != [llength $prevweatherlook]} {
			if {$iwsdisplayby == "notice"} {
				putquick "NOTICE $nick : [lindex $prevweatherlook $countelement]"
			} elseif {$iwsdisplayby == "pv"} {
				putquick "PRIVMSG $nick : [lindex $prevweatherlook $countelement]"
			} {
				putquick "PRIVMSG $chan : [lindex $prevweatherlook $countelement]"
			}
			incr countelement
		}
		return 0
	}
	
	# The actual weather

	set erroronconnection "0"
	set connectionok "0"
	set redirection "0"
	
#	putlog "lien encore : $weatherlnk"
	while {$connectionok == "0"} {
		#set token [http::geturl $weatherlnk -timeout 10000]
		if { [catch {http::geturl $weatherlnk -timeout 30000} token] } {
			if { [catch {http::geturl $weatherlnk -timeout 20000} token] } {
				putlog "Problem when we want to connect to : $weatherlnk"
				if {[info exists token]} {
					set finishhttp [http::Finish $token]
				}
				return 0
			}
		}
		# If there is redirect error (301 or 302) by Neil Madden.
		while {([http::ncode $token] == 301) || ([http::ncode $token] == 302)} { 
			upvar #0 $token state
			array set meta $state(meta)
			http::cleanup $token
			set token [http::geturl $meta(Location)]
			#putlog "la redirection : $meta(Location)"
			set redirection "1"
		}
		while {([http::ncode $token] == 301) || ([http::ncode $token] == 302)} {
			upvar #0 $token state
			array set meta $state(meta)
			http::cleanup $token
			set token [http::geturl $meta(Location)]
			set redirection "2"
		}
		if {([::http::status $token] == "ok")} {
			set weatherinfo [http::data $token]
			set finishhttp [http::Finish $token]
			set connectionok "1"
		} {
			if {$erroronconnection == "1"} {
				if {[::http::status $token] == "timeout"} {
					#prob
					putserv "PRIVMSG $nick : Connection Timeout..."
					if {[info exists token]} {
						set finishhttp [http::Finish $token]
					}
					return 0
				} {
					putlog "Connection error... to : $weatherlnk"
					if {[info exists token]} {
						set finishhttp [http::Finish $token]
					}
					return 0
				}
			}
			set finishhttp [http::Finish $token]
			set erroronconnection "1"
		}
	}

#	putlog "lien bisbis : $weatherlnk redirection : $redirection"  
	set weatherfile [open "$iws(tmpfile)" w]
	puts $weatherfile $weatherinfo
	close $weatherfile
		
	set weatherinfile [open "$iws(tmpfile)" r]
	set finfichier "0"
	while {![eof $weatherinfile] || $finfichier == "0"} {
		gets $weatherinfile poi
		set poi [string trim $poi]
		if {[string match -nocase "*meta http-equiv=\"Refresh\" content=\"*;URL=*\">*" $poi]} {
			set weatherlnk [string range [string trim $poi] [expr [string last "URL=" $poi] + 4] [expr [string first ">" $poi] - 2]]
			set erroronconnection "0"
			set connectionok "0"
			set redirection "0"
			while {$connectionok == "0"} {
				#set token [http::geturl $weatherlnk -timeout 10000]
				if { [catch {http::geturl $weatherlnk -timeout 30000} token] } {
					if { [catch {http::geturl $weatherlnk -timeout 20000} token] } {
						putlog "Problem when we want to connect to : $weatherlnk"
						if {[info exists token]} {
							set finishhttp [http::Finish $token]
						}
						return 0
					}
				}
				# If there is redirect error (301 or 302) by Neil Madden.
				while {([http::ncode $token] == 301) || ([http::ncode $token] == 302)} {
					upvar #0 $token state
					array set meta $state(meta)
					http::cleanup $token
					set token [http::geturl $meta(Location)]
					set redirection "1"
				}
				if {([::http::status $token] == "ok")} {
					set weatherinfo [http::data $token]
					set finishhttp [http::Finish $token]
					set connectionok "1"
				} {
					if {$erroronconnection == "1"} {
						if {[::http::status $token] == "timeout"} {
							#prob
							putserv "PRIVMSG $nick : Connection Timeout..."
							if {[info exists token]} {
								set finishhttp [http::Finish $token]
							}
							return 0
						} {
							putlog "Connection error... to : $weatherlnk"
							if {[info exists token]} {
								set finishhttp [http::Finish $token]
							}
							return 0
						}
					}
					set finishhttp [http::Finish $token]
					set erroronconnection "1"
				}
			}
			close $weatherinfile
			set weatherfile [open "$iws(tmpfile)" w]
			puts $weatherfile $weatherinfo
			close $weatherfile
			set weatherinfile [open "$iws(tmpfile)" r]
			set finfichier "1"
		}
		if {[string match -nocase "*</head>*" $poi]} {
			set finfichier "1"
		}
	}
	close $weatherinfile
	set weatherinfile [open "$iws(tmpfile)" r]
	# put all var to "" because if there is a problem and we can't detect something, then there is an error...
	set vent ""
	set pointderos ""
	set humidite ""
	set visibilite ""
	set weather ""
	set pression ""
	set temp ""
	set indUV ""
	set qtUV ""
	set nameofcity ""
	set meteoprob ""
	set themeteoprob ""
	set uv ""
	set wind ""
	set ihavecityname "0"
	set nameofcitynear ""
	set textonly "0"
	if {$thedefsite == "0"} {
		while {![eof $weatherinfile]} {
			gets $weatherinfile poi
			set poi [string trim $poi]
			#putlog "$poi"
			if {$nameofcitynear == "1"} {
				set nameofcity [string range [string trim $poi] 0 [expr [string first "<BR>" $poi] - 1]]
				set nameofcitynear "2"
			}
			if {[string match "*<TITLE>*</TITLE>*" $poi]} {
				set nameofcity [string range [string trim $poi] [expr [string last " - " $poi] + 3] [expr [string first "</TITLE>" $poi] - 1]]
				if {$nameofcity == "Local Weather Page"} {
					set nameofcity "$arg"
					regsub -all -- "%20" $nameofcity " " nameofcity
				} elseif {$nameofcity == "Local Travel Page"} {
					set nameofcity "$arg"
					regsub -all -- "%20" $nameofcity " " nameofcity
				}
			}
			if {[string match "*<!-- Insert City Name and Zip Code -->*" $poi]} {
				set nameofcity [string range [string trim $poi] [expr [string last "-->" $poi] + 3] [expr [string first "<BR>" $poi] - 1]]
				if {$nameofcity == ""} {
					set nameofcitynear "1"
				}
			}
			if {[string match "*<TITLE>weather.com*" $poi]} {
				set changelng "2"
				set langiws "us"
			}
			# if there is a weather alert...
			if {[string match "*<TD WIDTH=\"490\" CLASS=\"moduleTitle\">*</TD>*" $poi]} {
				set meteoprob [string range [string trim $poi] [expr [string first "CLASS=\"moduleTitle\">" $poi] + 20] [expr [string first "</TD>" $poi] - 1]]
			}
			if {[string match "*var marqueecontents=*Alert*/weather/alerts/?alertId=*/weather/alerts/?alertId=*,scrollbars')*" $poi]} {
				set themeteoprob [string range [string trim $poi] [expr [string first ",scrollbars')\\\">" $poi] + 16] [expr [string first "</A>&nbsp;&nbsp;&nbsp;" $poi] - 1]]
			}
			# for the us language
			if {$langiws == "us"} {
				# for us :
				#putlog "us language"
				if {([string match -nocase "*<b>* Forecast for*</b>*" $poi] && $ihavecityname =="0")} {
					set nameofcity [string range [string trim $poi] [expr [string first "for" $poi] + 3] [expr [string first "</B>" $poi] - 1]]
					set ihavecityname "1"
					#putlog "j'ai le nom de la ville :) : $nameofcity - $poi"
				}
				if {[string match -nocase "*Temp*>*&deg;F</B>*" $poi]} {
					#set poi [string tolower $poi]
					set temp [string range [string trim $poi] [expr [string first "obsTempTextA>" $poi] + 13] [expr [string first "&deg;" $poi] - 1]]
				}
				#if {[string match "*<!-- insert forecast*" $poi]} {
				#	set weather [string range [string trim $poi] [expr [string first "-->" $poi] + 3] [expr [string first "</TD>" $poi] - 1]]
				#}
				if {([string match "*<B CLASS=obsTextA>*</B></TD>*" $poi] && $weather == "")} {
					set weather [string range [string trim $poi] [expr [string first "obsTextA>" $poi] + 9] [expr [string first "</B>" $poi] - 1]]
					set weather [virehtmletrefoustrucnormaliws $weather]
				}
				#if {[string match "*>From*&nbsp;mph</TD>*" $poi]} {
				#	set vent [string range [string trim $poi] [expr [string first "obsTextBlue\">" $poi] + 13] [expr [string first "</TD>" $poi] - 1]]
				#	set vent [virehtmletrefoustrucnormaliws $vent]
				#	#putlog "j'ai le vent : $vent"
				#}
				
				if {[string match "*obsTextA*" $poi]} {
					
					if {$vent == "" } {
						if {$textonly == "1" } {
							putlog "pb after that... vent"
							set vent [string range [string trim $poi] [expr [string first "obsTextA" $poi] + 10] [expr [string first "</td>" $poi] - 1]]
							set vent [virehtmletrefoustrucnormaliws $vent]
							set textonly "0"
						} {
							set textonly "1"
						}						
					} elseif {$humidite == "" } {
						if {$textonly == "1" } {
							putlog "pb after that... humidite"
							set humidite [string range [string trim $poi] [expr [string first "obsTextA" $poi] + 10] [expr [string first "</td>" $poi] - 1]]
							set textonly "0"
						} {
							set textonly "1"
						}
					} elseif {$pression == "" } {
						if {$textonly == "1" } {
							putlog "pb after that... pression"
							set pression [string range [string trim $poi] [expr [string first "obsTextA" $poi] + 10] [expr [string first "." $poi] - 1]]
							set textonly "0"
						} {
							set textonly "1"
						}
					} elseif {$pointderos == "" } {
						if {$textonly == "1" } {
							putlog "pb after that... pt de ros"
							set pointderos [string range [string trim $poi] [expr [string first "obsTextA" $poi] + 10] [expr [string first "</td>" $poi] - 1]]
							set textonly "0"
						} {
							set textonly "1"
						}
					}
				}
			
			} {
			# for the other language :)
				if {[string match "*align=\"center\" CLASS=\"obsText\">*" $poi]} {
					set weather [string range [string trim $poi] [expr [string first "CLASS=\"obsText\">" $poi] + 16] [expr [string first "<BR>" $poi] - 1]]
				}
				if {[string match "*<TD CLASS=\"obsText\" ALIGN=\"CENTER\"><B>*" $poi] && $weather == ""} {
					set weather [string range [string trim $poi] [expr [string first "ALIGN=\"CENTER\"><B>" $poi] + 18] [expr [string first "</B></TD>" $poi] - 1]]
				}
				if {[string match "*<TD COLSPAN=\"2\" CLASS=\"obsTempText\" VALIGN=\"TOP\">&nbsp;*" $poi]} {
					set temp [string range [string trim $poi] [expr [string first ">&nbsp;" $poi] + 7] [expr [string first "&deg;C</TD>" $poi] - 1]]
				}
				if {[string match "*<TD CLASS=\"obsTempText\" ALIGN=\"CENTER\"><B>*&deg;C</B></TD>*" $poi]} {
					set temp [string range [string trim $poi] [expr [string first "<B>" $poi] + 3] [expr [string first "&deg;C</B></TD>" $poi] - 1]]
				}
				if {[string match "*<TD CLASS=\"currentObsText\">*" $poi]} {
					if {$langiws == "uk"} {
						if {$indUV == ""} {
							set indUV [string range [string trim $poi] [expr [string first "<TD CLASS=\"currentObsText\">" $poi] + 27] [expr [string first "</TD>" $poi] - 1]]
							set indUV [virehtmletrefoustrucnormaliws $indUV]
						} elseif {$vent == ""} {
							set vent [string range [string trim $poi] [expr [string first "<TD CLASS=\"currentObsText\">" $poi] + 27] [expr [string first "</TD>" $poi] - 1]]
							set vent [virehtmletrefoustrucnormaliws $vent]					
						} elseif {$pointderos == ""} {
							set pointderos [string range [string trim $poi] [expr [string first "<TD CLASS=\"currentObsText\">" $poi] + 27] [expr [string first "</TD>" $poi] - 1]]
						} elseif {$humidite == ""} {
							set humidite [string range [string trim $poi] [expr [string first "<TD CLASS=\"currentObsText\">" $poi] + 27] [expr [string first "</TD>" $poi] - 1]]
						} elseif {$visibilite == ""} {
							set visibilite [string range [string trim $poi] [expr [string first "<TD CLASS=\"currentObsText\">" $poi] + 27] [expr [string first "</TD>" $poi] - 1]]
							set visibilite "1"
						} {
							set pression [string range [string trim $poi] [expr [string first "<TD CLASS=\"currentObsText\">" $poi] + 27] [expr [string first "</TD>" $poi] - 1]]
						}
					} {
						if {$vent == ""} {
							set vent [string range [string trim $poi] [expr [string first "<TD CLASS=\"currentObsText\">" $poi] + 27] [expr [string first "</TD>" $poi] - 1]]
							set vent [virehtmletrefoustrucnormaliws $vent]
						} elseif {$pointderos == ""} {
							set pointderos [string range [string trim $poi] [expr [string first "<TD CLASS=\"currentObsText\">" $poi] + 27] [expr [string first "</TD>" $poi] - 1]]
						} elseif {$humidite == ""} {
							set humidite [string range [string trim $poi] [expr [string first "<TD CLASS=\"currentObsText\">" $poi] + 27] [expr [string first "</TD>" $poi] - 1]]
						} elseif {$visibilite == ""} {
							set visibilite [string range [string trim $poi] [expr [string first "<TD CLASS=\"currentObsText\">" $poi] + 27] [expr [string first "</TD>" $poi] - 1]]
							set visibilite "1"
						} {
							set pression [string range [string trim $poi] [expr [string first "<TD CLASS=\"currentObsText\">" $poi] + 27] [expr [string first "</TD>" $poi] - 1]]
						}
					}
				}
				if {[string match "*<FONT CLASS=\"obsTempText\">*" $poi]} {
					set indUV [string range [string trim $poi] [expr [string first "<FONT CLASS=\"obsTempText\">" $poi] + 26] [expr [string first "</FONT" $poi] - 1]]
					set qtUV [string range [string trim $poi] [expr [string first "<BR>" $poi] + 4] [expr [string first "</TD>" $poi] - 1]]
				}
			}
			# We now have all weather info we need :)
			
		}
	} elseif {$thedefsite == "1"} {
		set tempok "0"
		set thetrucchose "0"
		set pouce "0"
		set pressionok "0"
		set ventok "0"
		set thereisweather "0"
		while {![eof $weatherinfile]} {
			gets $weatherinfile poi
			set poi [string trim $poi]
			if {[string match -nocase "*<td colspan=2 class=smalltableheader>*" $poi]} {
				set thereisweather "1"
			}
			if {[string match -nocase "*<title>*Search*</title>*" $poi]} {
				putserv "PRIVMSG $nick : There is more than one result... Please be more precise..."
				if {[info exists token]} {
					set finishhttp [http::Finish $token]
				}
				return 0	
			}
			if {[string match -nocase "*b><font size=* color=#ffffff>*</font></b>*" $poi]} {
				set nameofcity [string range [string trim $poi] [expr [string last "ff>" $poi] + 3] [expr [string first "</font>" $poi] - 1]]
			}
			if {([string match -nocase "*<b>*</b>&nbsp;&#176;*" $poi] && $tempok == "0")} {
				set temptp [string range [string trim $poi] [expr [string first "<b>" $poi] + 3] [expr [string first "</b>" $poi] - 1]]
				if {$temp != ""} {
					set temp "$temptpC/$tempF"
					set tempok "1"
				} {
					set temp "$temptp"
				}
			}
			if {[string match -nocase "*<tr BGCOLOR=*#FFFFFF*><td>*" $poi] || [string match -nocase "*<tr BGCOLOR=*#ddeeff*><td>*" $poi]} {
				set thetrucchose [expr $thetrucchose + 1]
			}
			if {([string match -nocase "*</b>&nbsp;&#176;F*" $poi] && $thetrucchose == "2")} {
				set thetrucchose [expr $thetrucchose - 1]
			}
			if {([string match -nocase "*<td><b>*</b></td></tr>*" $poi] && $thetrucchose == "1")} {
				set humidite [string range [string trim $poi] [expr [string first "<b>" $poi] + 3] [expr [string first "</b>" $poi] - 1]]
			}
			if {([string match -nocase "*<td><b>*</b> *" $poi] && $thetrucchose == "4")} {
				set vent [string range [string trim $poi] [expr [string first "<b>" $poi] + 3] [expr [string first "</b>" $poi] - 1]]
				set vent "$vent [string range [string trim $poi] [expr [string first "</b>" $poi] + 4] [string length $poi]]"
			}
			if {([string match -nocase "*<b>*</b>&nbsp;mph*" $poi] && $ventok == "0")} {
				set vent "$vent [string range [string trim $poi] [expr [string first "<b>" $poi] + 3] [expr [string first "</b>" $poi] - 1]]mph/"
			}
			if {([string match -nocase "*<b>*</b>&nbsp;km/h*" $poi] && $ventok == "0")} {
				set vent "$vent[string range [string trim $poi] [expr [string first "<b>" $poi] + 3] [expr [string first "</b>" $poi] - 1]]km/h"
				set ventok "1"
			}
			if {([string match -nocase "*<b>*</b>&nbsp;i*" $poi] && $pressionok == 0)} {
				set pression [string range [string trim $poi] [expr [string first "<b>" $poi] + 3] [expr [string first "</b>" $poi] - 1]]
			}
			if {([string match -nocase "*<b>*</b>&nbsp;pouce*" $poi] && $pouce == 0)} {
				set pression [string range [string trim $poi] [expr [string first "<b>" $poi] + 3] [expr [string first "</b>" $poi] - 1]]
				set pouce "1"
			}
			if {([string match -nocase "*<b>*</b>&nbsp;hPa*" $poi] && $pressionok == "0")} {
				if {$pouce == "0"} {
					set pression "$pression in/[string range [string trim $poi] [expr [string first "<b>" $poi] + 3] [expr [string first "</b>" $poi] - 1]]hPa"
				} elseif {$pouce == "1"} {
					set pression "$pression pouce/[string range [string trim $poi] [expr [string first "<b>" $poi] + 3] [expr [string first "</b>" $poi] - 1]]hPa"
				}
				set pressionok "1"
			}
			if {([string match -nocase "*<td><b>*</b></td></tr>*" $poi] && $thetrucchose =="5")} {
				set weather [string range [string trim $poi] [expr [string first "<b>" $poi] + 3] [expr [string first "</b>" $poi] - 1]]
			}
		}
		if {$thereisweather == "0"} {
			putserv "PRIVMSG $nick : Sorry, no weather available for this city..."
			return 0
		}
	}
	close $weatherinfile
	
	
	# Debug proc
	if {($weather == "" || $temp == "" || $iws(alwaysdebugon) == "1" || $iwsdebugon == "1")} {
		if {[matchchanattr $nick m|m $chan] || [matchchanattr $nick n|n $chan]} {
			putserv "PRIVMSG $nick : You are the master of this eggdrop. This script can't work correctly, there is a bug or something else..."
			set writeindebugfile [open "$iws(debugfile)" w]
			puts $writeindebugfile "***** International Weather Script (IWS) by Ycarus *****"
			puts $writeindebugfile " IWS version : $iws(ver) - Eggdrop version : $numversion - TCL version : $tcl_version"
			puts $writeindebugfile "Platform : $tcl_platform(platform) - Machine : $tcl_platform(machine) - OS : $tcl_platform(os) - Version : $tcl_platform(osVersion)"
			puts $writeindebugfile "Language : $langiws"
			puts $writeindebugfile "The user ask for : $askuserfor"
			puts $writeindebugfile "The link we use is : $weatherlnk"
			puts $writeindebugfile "The tmp file is : $iws(tmpfile)"
			puts $writeindebugfile "var : weather : $weather - temp : $temp - wind : $vent - humidity : $humidite - barometer : $pression - uv : $indUV - meteoprob : $meteoprob"
			puts $writeindebugfile "lng $iws(lang) - defuser $iws(allowdefuser) - alwaysdebugon $iws(alwaysdebugon) - Changelng $changelng - Redirection $redirection"
			puts $writeindebugfile "display look : $iws(displaylook)"
			puts $writeindebugfile "display prev look : $iws(displaylookpre)"
			puts $writeindebugfile "separator : $iws(dayseparator) - chan actif : $iws(activeon) - notice : $iws(notice) - channel : $iws(channel) - pv : $iws(pv)"
			puts $writeindebugfile "---------- iwstmpfile : $iws(tmpfile) ----------------"
			set weatherinfile [open "$iws(tmpfile)" r]
			while {![eof $weatherinfile]} {
				gets $weatherinfile poi
				set poi [string trim $poi]
				puts $writeindebugfile "$poi"
			}
			close $weatherinfile
			puts $writeindebugfile "------------ End of the file -----------"
			close $writeindebugfile
			putserv "PRIVMSG $nick : You can test if there is a new version : ${iws(trigger)}update (in private with YOUR bot)"
			putserv "PRIVMSG $nick : If there is no new version, please, send the file : $iws(debugfile) to yews@ifrance.com"
		}
		
	}
	# putlog "conversion"
	# we can now put this info on the chan :)
	if {($meteoprob == "" || $temp != "")} {
		set countelement "0"
		if {($iws(celsiusfahrenheitandkmhmph) == "1" && $thedefsite == "0")}  {
			if {$langiws == "us"} {
				if  {[string is integer -strict $temp]} {
					set temp "[expr (($temp - 32) * 10) / 18]C/$tempF"
				}
				if {$vent != ""} {
					if {[string match "*calm mph*" $vent]} {
						regsub -all -- "mph" $vent "" vent
					}
					if {[string match "*mph*" $vent]} {
						set ventprevious $vent
						set vent [string range [string trim $vent] 0 [expr [string first "mph" $vent] - 3]]
						set commentvent [string range [string trim $vent] 0 [expr [string last " " $vent] - 1]]
						set vent [string range [string trim $vent] [expr [string last " " $vent] + 1] [string length $vent]]
						# If there is a bug here : update to TCL 8.3...
						# I want to find if it's a number (0123456789)
						if {(![string is digit -strict $vent] || $vent == "calm")} {
							set vent $ventprevious
						} {
							set vent "$commentvent [expr ($vent * 8) / 5] km/h - $vent mph"
						}
					}
				}
			} {
				if  {[string is integer -strict $temp]} {
					set temp "$tempC/[expr ($temp * 1.8) + 32]F"
				}
				# There is a problem with the wind : it's not the same think for all languages. 
				#So I will correct that in the next version of this script.
				#set vent [string range [string trim $vent] 0 [expr [string first "km" $vent] - 2]]
				#set commentvent [string range [string trim $vent] 0 [expr [string last " " $vent] - 1]]
				#set vent [string range [string trim $vent] [expr [string last " " $vent] + 1] [string length $vent]]
				#set vent "$commentvent $vent km/h - [expr ($vent / 8) * 5] mph"
			}
			set actualweatherlook [putdisplayokiws $iws(displaylook) [lindex $txtiws 3] $nameofcity $weather $temp "" [lindex $txtiws 5] $vent [lindex $txtiws 6] $humidite [lindex $txtiws 7] $pression [lindex $txtiws 8] $indUV $qtUV]
		} {
			if {$thedefsite == "0"} {
				set actualweatherlook [putdisplayokiws $iws(displaylook) [lindex $txtiws 3] $nameofcity $weather $temp [lindex $txtiws 4] [lindex $txtiws 5] $vent [lindex $txtiws 6] $humidite [lindex $txtiws 7] $pression [lindex $txtiws 8] $indUV $qtUV]
			} elseif {$thedefsite == "1"} {
				set actualweatherlook [putdisplayokiws $iws(displaylookwu) [lindex $txtiws 3] $nameofcity $weather $temp "" [lindex $txtiws 5] $vent [lindex $txtiws 6] $humidite [lindex $txtiws 7] $pression [lindex $txtiws 8] $indUV $qtUV]
			}
		
		}
		while {$countelement != [llength $actualweatherlook]} {
				if {$iwsdisplayby == "notice"} {
					putquick "NOTICE $nick : [lindex $actualweatherlook $countelement]"
				} elseif {$iwsdisplayby == "pv"} {
					putquick "PRIVMSG $nick : [lindex $actualweatherlook $countelement]"
				} {
					putquick "PRIVMSG $chan : [lindex $actualweatherlook $countelement]"
				}
			incr countelement
		}
	} {
		putserv "PRIVMSG $chan :\002 [lindex $txtiws 3] $nameofcity \002: $meteoprob $themeteoprob"
	}
}




# this 2 procedure are to use the look we set at the beginning of the script. It's the only way I found to do this...
proc putdisplayokpreviws {prevweatherlook forecast nameofcity weather1 weather2 weather3} {
	global botnick
	regsub -all -- "%botnick%" $prevweatherlook "$botnick" prevweatherlook
	regsub -all -- "%nameofcity%" $prevweatherlook "$nameofcity" prevweatherlook
	regsub -all -- "Forecast" $prevweatherlook "$forecast" prevweatherlook
	regsub -all -- "%weather1%" $prevweatherlook "$weather1" prevweatherlook
	regsub -all -- "%weather2%" $prevweatherlook "$weather2" prevweatherlook
	regsub -all -- "%weather3%" $prevweatherlook "$weather3" prevweatherlook
	regsub -all -- \\\} $prevweatherlook "" prevweatherlook
	regsub -all -- \\\{ $prevweatherlook "" prevweatherlook
	return $prevweatherlook
}

proc putdisplayokiws {actualweatherlook wordweather nameofcity weather temp degfar wordvent vent wordhumidite humidite wordpression pression wordinduv indUV qtUV} {
	global botnick
	regsub -all -- "%botnick%" $actualweatherlook "$botnick" actualweatherlook
	regsub -all -- "Weather" $actualweatherlook "$wordweather" actualweatherlook
	regsub -all -- "%nameofcity%" $actualweatherlook "$nameofcity" actualweatherlook
	regsub -all -- "%weather%" $actualweatherlook "$weather" actualweatherlook
	regsub -all -- "%temp%" $actualweatherlook "$temp" actualweatherlook
	regsub -all -- "C" $actualweatherlook "$degfar" actualweatherlook
	regsub -all -- "Wind" $actualweatherlook "$wordvent" actualweatherlook
	regsub -all -- "%vent%" $actualweatherlook "$vent" actualweatherlook
	regsub -all -- "Humidity" $actualweatherlook "$wordhumidite" actualweatherlook
	regsub -all -- "%humidite%" $actualweatherlook "$humidite" actualweatherlook
	regsub -all -- "Barometer" $actualweatherlook "$wordpression" actualweatherlook
	regsub -all -- "%pression%" $actualweatherlook "$pression" actualweatherlook
	regsub -all -- "Sun Index" $actualweatherlook "$wordinduv" actualweatherlook
	regsub -all -- "%indUV%" $actualweatherlook "$indUV" actualweatherlook
	regsub -all -- "%qtUV%" $actualweatherlook "$qtUV" actualweatherlook
	return $actualweatherlook
}

# There is a problem without this... You can send something to a file...
proc check_string {text} { 
  regsub -all ">" $text "" text 
  regsub -all "<" $text "" text 
  regsub -all "|" $text "" text 
  regsub -all "&" $text "" text 
  return $text 
} 


# The update proc, with this the update of the script is really easy !
proc iws_auto_update { nick uhost handle arg } {
	global iwsupdate iws
	putquick "PRIVMSG $nick : Search for a new version"
	putlog "Search for new version of IWS"
	set thenotice ""
	set newversion "0"
	set linkupdate "$iwsupdate(lnk)$iwsupdate(filename).txt"
	if { [catch {http::geturl $linkupdate -timeout 10000} token] } {
		putserv "PRIVMSG $nick : Can't connect to the update site"
	}
	# If there is redirect error (301 or 302) by Neil Madden.
	while {([http::ncode $token] == 301) || ([http::ncode $token] == 302)} {
		upvar #0 $token state
		array set meta $state(meta)
		http::cleanup $token
		set token [http::geturl $meta(Location)]
	}
	if {([::http::status $token] == "ok")} {
		set scriptversion [http::data $token]
		set finishhttp [http::Finish $token]
	} {
		if {[::http::status $token] == "timeout"} {
			#prob
			putserv "PRIVMSG $nick : Connection Timeout"
			if {[info exists token]} {
				set finishhttp [http::Finish $token]
			}
			return 0
		} {
			putlog "Connection error to : $linkupdate"
			if {[info exists token]} {
				set finishhttp [http::Finish $token]
			}
			return 0
		}
	}
	if {[info exists token]} {
		set finishhttp [http::Finish $token]
	}
	
	set scriptversiontmp [open "$iws(tmpfile)" w]
	puts $scriptversiontmp $scriptversion
	close $scriptversiontmp
	set scriptversionfile [open "$iws(tmpfile)" r]
	while {![eof $scriptversionfile]} {
		gets $scriptversionfile poi
		set poi [string trim $poi]
		if {!($poi == $iws(ver) || $poi == "")} {
			putquick "PRIVMSG $nick : There is a new version of the script : This is version $poi (you have version $iws(ver))."
			putquick "PRIVMSG $nick : Downloading"
			putlog "New version of IWS detected !!! Downloading"
			set newversion "1"
		}
	}
	if {$newversion == "1"} {
		set linkupdate "$iwsupdate(lnk)$iwsupdate(filename).tcl"
		if { [catch {http::geturl $linkupdate -timeout 10000} token] } {
			putserv "PRIVMSG $nick : Can't connect to the update site"
		}
		# If there is redirect error (301 or 302) by Neil Madden.
		while {([http::ncode $token] == 301) || ([http::ncode $token] == 302)} {
			upvar #0 $token state
			array set meta $state(meta)
			http::cleanup $token
			set token [http::geturl $meta(Location)]
		}
		if {([::http::status $token] == "ok")} {
			set thescript [http::data $token]
			set finishhttp [http::Finish $token]
		} {
			if {[::http::status $token] == "timeout"} {
				#prob
				putserv "PRIVMSG $nick : Connection Timeout"
				if {[info exists token]} {
					set finishhttp [http::Finish $token]
				}
				return 0
			} 
		}
		if {[info exists token]} {
			set finishhttp [http::Finish $token]
		}
		set scriptfinal [open "$iws(tmpfile)" w]
		puts $scriptfinal $thescript
		close $scriptfinal
		putlog "OK ! IWS Downloaded !"
		set scriptfinal [open "$iws(tmpfile)" r]
		set finalfile [open "$iws(scriptpath)$iwsupdate(filename).tcl" w]
		putquick "PRIVMSG $nick : Download OK !!! Now update of the script configuration"
		putlog "Update of the config"
		set debconfig "0"
		while {(![eof $scriptfinal]) || ($debconfig != "2")} {
			gets $scriptfinal poi
			set poi [string trim $poi]
			if {([string match "*.endconf*" $poi] && $debconfig == "1")} {
				set debconfig "2"
			}
			if {([string match "*set*iws*" $poi] && $debconfig == "1")} {
				set varname [string range [string trim $poi] [expr [string first "iws" $poi] + 4] [expr [string first "\)" $poi] - 1]]
				if {[string match "*\{*\}*" $poi]} {
					set poi [string replace $poi [expr [string first "\{" $poi] + 1] [expr [string first "\}" $poi [expr [string first "\{" $poi] + 1]] - 1] $iws($varname)]
				} {
					set poi [string replace $poi [expr [string first "\"" $poi] + 1] [expr [string first "\"" $poi [expr [string first "\"" $poi] + 1]] - 1] $iws($varname)]
				}
			}
			if {([string match "*.debconf*" $poi] && $debconfig == "0")} {
				set debconfig "1"
			}
			if {([string match "*.notice*" $poi] && $debconfig == "1")} {
				set thenotice [string range [string trim $poi] [expr [string first "notice" $poi] + 7] [string length $poi]]
				putquick "PRIVMSG $nick : $thenotice"
			}
			
			puts $finalfile $poi
		}
		close $scriptfinal
		close $finalfile
		putlog "Update complete ! Rehash"
		putquick "PRIVMSG $nick : Update OK!!! (the script rehash the conf)"
		
		rehash
	} {
		putserv "PRIVMSG $nick : No new version of the script"
		putlog "No new version of IWS"
	}
}


# ------------------------------------------
# --- Fin du script -- End of the script ---
# ------------------------------------------
putlog "***** International Weather Script (IWS) by Ycarus (v$iws(ver)) ***** The weather on IRC"
